package com.vass.gex;



import java.io.File;
import java.io.IOException;

import org.apache.log4j.Logger;

import com.appiancorp.suiteapi.common.Name;
import com.appiancorp.suiteapi.common.exceptions.InvalidVersionException;
import com.appiancorp.suiteapi.common.exceptions.PrivilegeException;
import com.appiancorp.suiteapi.common.exceptions.StorageLimitException;
import com.appiancorp.suiteapi.content.ContentConstants;
import com.appiancorp.suiteapi.content.ContentService;
import com.appiancorp.suiteapi.content.exceptions.DuplicateUuidException;
import com.appiancorp.suiteapi.content.exceptions.InsufficientNameUniquenessException;
import com.appiancorp.suiteapi.content.exceptions.InvalidContentException;
import com.appiancorp.suiteapi.knowledge.DocumentDataType;
import com.appiancorp.suiteapi.knowledge.FolderDataType;
import com.appiancorp.suiteapi.process.exceptions.SmartServiceException;
import com.appiancorp.suiteapi.process.framework.AppianSmartService;
import com.appiancorp.suiteapi.process.framework.Input;
import com.appiancorp.suiteapi.process.framework.Required;
import com.appiancorp.suiteapi.process.framework.SmartServiceContext;
import com.appiancorp.suiteapi.process.palette.PaletteCategoryConstants;
import com.appiancorp.suiteapi.process.palette.PaletteInfo;
import com.appiancorp.suiteapi.type.TypeService;
import com.vass.gex.AppianBase64Utils;
import com.appiancorp.suiteapi.knowledge.Document;



@PaletteInfo(paletteCategory = PaletteCategoryConstants.INTEGRATION_SERVICES , palette = "Connectivity Services")
public class convertToBase64 extends AppianSmartService{
	
	private static final Logger LOG = Logger.getLogger(convertToBase64.class);
	
	// inputs
	
	  private Long document;
	  
	 
	 

	  // outputs
	  private String base64String;
	  private String errorMessage;
	  private boolean isError;
	

	private final SmartServiceContext smartServiceCtx;
	private ContentService contentService;

	
	
	/** 
	 * constructor que recupera el contexto de appian 
	 **/
	public convertToBase64(SmartServiceContext smartServiceCtx,
			ContentService cs, TypeService ts) {
		super();
		this.smartServiceCtx = smartServiceCtx;
		this.contentService = cs;
	}
	
	
	
	@Override
	public void run() throws SmartServiceException {
		
			    try 
			    {
			    	
			    	Document documentF = this.contentService.download(document, com.appiancorp.suiteapi.content.ContentConstants.VERSION_CURRENT, Boolean.valueOf(true))[0];
			    	
			    	base64String = AppianBase64Utils.encodeDocumentToBase64(documentF);
			      	isError = false;
				    errorMessage = "";
			            
			    } catch (  IOException | PrivilegeException | InvalidContentException | InvalidVersionException e) {
			      isError = true;
			      errorMessage = e.getMessage();
			      LOG.error(e.getMessage(), e);
			    }
		
		
	}
	
	
	//input
	
	
	
	
	@Input(required = Required.ALWAYS)  
	  @Name("document")
	  @DocumentDataType
	  public void setDocument(Long document) {
	    this.document=document;
	  }
	
	  
	  

	  // outputs
	  
	  @Name("base64String")
	  public String getBase64String() {
	    return base64String;
	  }

	  @Name("isError")
	  public boolean isError() {
	    return isError;
	  }

	  @Name("errorMessage")
	  public String getErrorMessage() {
	    return errorMessage;
	  }
}
